package net.ihe.gazelle.proxy.factory;

import net.ihe.gazelle.proxy.listeners.TlsRawEventListener;
import net.ihe.gazelle.proxy.netty.ChannelType;
import net.ihe.gazelle.proxy.netty.ConnectionConfig;
import net.ihe.gazelle.proxy.netty.Proxy;
import net.ihe.gazelle.proxy.netty.ProxyFactory;
import net.ihe.gazelle.proxy.netty.protocols.tlsRaw.TlsRawProxy;
import org.kohsuke.MetaInfServices;

@MetaInfServices(ProxyFactory.class)
public class TlsRawProxyFactory implements ProxyFactory {

    @Override
    public Proxy<?, ?> newProxy(ConnectionConfig connectionConfig) {
        TlsRawEventListener proxyEventListener = new TlsRawEventListener();
        return new TlsRawProxy(proxyEventListener, connectionConfig);
    }


    @Override
    public ChannelType getChannelType() {
        return ChannelType.TLSRAW;
    }

}
