package net.ihe.gazelle.proxy.listeners;

import net.ihe.gazelle.hql.providers.detached.HibernateActionPerformer;
import net.ihe.gazelle.hql.providers.detached.HibernateFailure;
import net.ihe.gazelle.hql.providers.detached.PerformHibernateAction;
import net.ihe.gazelle.proxy.model.message.TlsRawMessage;
import net.ihe.gazelle.proxy.netty.channel.ProxySide;

import javax.persistence.EntityManager;
import java.sql.Timestamp;

public class TlsRawEventListener extends SameEventListener<byte[]> {

    public TlsRawEventListener() {
        super();
    }

    protected void saveMessage(final Timestamp timeStamp, final byte[] message, final String requesterIp,
                               final int requesterPort, final int proxyPort, final String responderIp, final int responderPort,
                               final int requestChannelId, final int responseChannelId, final ProxySide side) {
        // Messages are coming from different threads!
        synchronized (this) {

            try {
                HibernateActionPerformer.performHibernateAction(new PerformHibernateAction() {
                    @Override
                    public Object performAction(EntityManager entityManager, Object... context) throws Exception {
                        TlsRawMessage tlsRawmessage = new TlsRawMessage(timeStamp, requesterIp, requesterPort, proxyPort,
                                responderIp, responderPort, side);
                        tlsRawmessage.setMessageReceived(message);
                        processMessage(entityManager, tlsRawmessage, requestChannelId, responseChannelId);
                        return null;
                    }
                });
            } catch (HibernateFailure e) {
                // Already logged
            }
        }
    }
}
