package net.ihe.gazelle.proxy.netty;

import java.util.List;

import org.jboss.netty.channel.ChannelHandler;

public interface ConnectionConfig {

    // Add specific handlers when a client connects to the server proxy (mainly
    // for TLS)
    List<ChannelHandler> getHandlersForProxyProvider();

    // Add specific handlers when server proxy connects to the forwarded server
    // (mainly for TLS)
    List<ChannelHandler> getHandlersForProxyConsumer();

    /**
     * Returns the port open on proxy side
     *
     * @return
     */
    int getProxyProviderPort();

    /**
     * Returns the host name / IP address of the remote host to contact
     *
     * @return
     */
    String getProxyConsumerHost();

    /**
     * Returns the port of the remote host to contact
     *
     * @return
     */
    int getProxyConsumerPort();

    /**
     * Returns the type of channel to open (HL7, Dicom...)
     *
     * @return
     */
    ChannelType getChannelType();

}